//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Client.MultiClientTest.MultiClientTest
{
    
    
    /// <summary>
    /// Class that implements the IMultiClientTest interface through SiLA2
    /// </summary>
    public partial class MultiClientTestClient : IMultiClientTest
    {
        
        private IClientExecutionManager _executionManager;
        
        private IClientChannel _channel;
        
        private const string _serviceName = "sila2.org.silastandard.test.multiclienttest.v1.MultiClientTest";
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="channel">The channel through which calls should be executed</param>
        /// <param name="executionManager">A component to determine metadata to attach to any requests</param>
        public MultiClientTestClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            _executionManager = executionManager;
            _channel = channel;
        }
        
        /// <summary>
        /// Multiple invocations of this command will be running in parallel
        /// </summary>
        /// <param name="duration">The duration of the command execution</param>
        public virtual Tecan.Sila2.IObservableCommand RunInParallel(double duration)
        {
            RunInParallelRequestDto request = new RunInParallelRequestDto(duration, null);
            request.Validate();
            return _channel.ExecuteObservableCommand<RunInParallelRequestDto>(_serviceName, "RunInParallel", request, ConvertRunInParallelException, _executionManager.CreateCallOptions(request.CommandIdentifier));
        }
        
        /// <summary>
        /// Converts the error ocurred during execution of RunInParallel to a proper exception
        /// </summary>
        /// <param name="errorIdentifier">The identifier of the error that has happened</param>
        /// <param name="errorMessage">The original error message from the server</param>
        /// <returns>The converted exception or null, if the error is not understood</returns>
        private static System.Exception ConvertRunInParallelException(string errorIdentifier, string errorMessage)
        {
            return null;
        }
        
        /// <summary>
        /// Multiple invocations of this command will be queued
        /// </summary>
        /// <param name="duration">The duration of the command execution</param>
        public virtual Tecan.Sila2.IObservableCommand RunQueued(double duration)
        {
            RunQueuedRequestDto request = new RunQueuedRequestDto(duration, null);
            request.Validate();
            return _channel.ExecuteObservableCommand<RunQueuedRequestDto>(_serviceName, "RunQueued", request, ConvertRunQueuedException, _executionManager.CreateCallOptions(request.CommandIdentifier));
        }
        
        /// <summary>
        /// Converts the error ocurred during execution of RunQueued to a proper exception
        /// </summary>
        /// <param name="errorIdentifier">The identifier of the error that has happened</param>
        /// <param name="errorMessage">The original error message from the server</param>
        /// <returns>The converted exception or null, if the error is not understood</returns>
        private static System.Exception ConvertRunQueuedException(string errorIdentifier, string errorMessage)
        {
            return null;
        }
        
        /// <summary>
        /// Invocations will be rejected, if there is another command instance already running
        /// </summary>
        /// <param name="duration">The duration of the command execution</param>
        public virtual Tecan.Sila2.IObservableCommand RejectParallelExecution(double duration)
        {
            RejectParallelExecutionRequestDto request = new RejectParallelExecutionRequestDto(duration, null);
            request.Validate();
            return _channel.ExecuteObservableCommand<RejectParallelExecutionRequestDto>(_serviceName, "RejectParallelExecution", request, ConvertRejectParallelExecutionException, _executionManager.CreateCallOptions(request.CommandIdentifier));
        }
        
        /// <summary>
        /// Converts the error ocurred during execution of RejectParallelExecution to a proper exception
        /// </summary>
        /// <param name="errorIdentifier">The identifier of the error that has happened</param>
        /// <param name="errorMessage">The original error message from the server</param>
        /// <returns>The converted exception or null, if the error is not understood</returns>
        private static System.Exception ConvertRejectParallelExecutionException(string errorIdentifier, string errorMessage)
        {
            return null;
        }
        
        private T Extract<T>(Tecan.Sila2.ISilaTransferObject<T> dto)
        
        {
            return dto.Extract(_executionManager.DownloadBinaryStore);
        }
    }
    
    /// <summary>
    /// Factory to instantiate clients for the Multi Client Test.
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IClientFactory))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class MultiClientTestClientFactory : IClientFactory
    {
        
        /// <summary>
        /// Gets the fully-qualified identifier of the feature for which clients can be generated
        /// </summary>
        public string FeatureIdentifier
        {
            get
            {
                return "org.silastandard/test/MultiClientTest/v1";
            }
        }
        
        /// <summary>
        /// Gets the interface type for which clients can be generated
        /// </summary>
        public System.Type InterfaceType
        {
            get
            {
                return typeof(IMultiClientTest);
            }
        }
        
        /// <summary>
        /// Creates a strongly typed client for the given execution channel and execution manager
        /// </summary>
        /// <param name="channel">The channel that should be used for communication with the server</param>
        /// <param name="executionManager">The execution manager to manage metadata</param>
        /// <returns>A strongly typed client. This object will be an instance of the InterfaceType property</returns>
        public object CreateClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            return new MultiClientTestClient(channel, executionManager);
        }
    }
}

